/*
 *
 * (C) 2004-2005 Denora Team
 * Contact us at info@nomadirc.net
 *
 * Please read COPYING and README for furhter details.
 *
 * Based on the original code of Anope by Anope Team.
 * Based on the original code of Thales by Lucas.
 * 
 * $Id: hyperion.h 427 2005-07-23 08:40:36Z trystan $
 *
 */

/*
[Jul 03 18:11:43.178544 2005] debug: unknown mode : usermode U (in :Trystan MODE Trystan :+AcdDfFGhHkKloRsSTuUvVWXyYzZ0123459)
[Jul 03 18:11:43.178752 2005] debug: unknown mode : usermode v (in :Trystan MODE Trystan :+AcdDfFGhHkKloRsSTuUvVWXyYzZ0123459)
[Jul 03 18:11:43.178960 2005] debug: unknown mode : usermode V (in :Trystan MODE Trystan :+AcdDfFGhHkKloRsSTuUvVWXyYzZ0123459)
[Jul 03 18:11:43.179182 2005] debug: unknown mode : usermode W (in :Trystan MODE Trystan :+AcdDfFGhHkKloRsSTuUvVWXyYzZ0123459)
[Jul 03 18:11:43.179391 2005] debug: unknown mode : usermode X (in :Trystan MODE Trystan :+AcdDfFGhHkKloRsSTuUvVWXyYzZ0123459)
[Jul 03 18:11:43.179607 2005] debug: unknown mode : usermode Y (in :Trystan MODE Trystan :+AcdDfFGhHkKloRsSTuUvVWXyYzZ0123459)
[Jul 03 18:11:43.179819 2005] debug: unknown mode : usermode Z (in :Trystan MODE Trystan :+AcdDfFGhHkKloRsSTuUvVWXyYzZ0123459)
[Jul 03 18:11:43.180040 2005] debug: unknown mode : usermode 0 (in :Trystan MODE Trystan :+AcdDfFGhHkKloRsSTuUvVWXyYzZ0123459)
[Jul 03 18:11:43.180249 2005] debug: unknown mode : usermode 1 (in :Trystan MODE Trystan :+AcdDfFGhHkKloRsSTuUvVWXyYzZ0123459)
[Jul 03 18:11:43.180457 2005] debug: unknown mode : usermode 2 (in :Trystan MODE Trystan :+AcdDfFGhHkKloRsSTuUvVWXyYzZ0123459)
[Jul 03 18:11:43.180664 2005] debug: unknown mode : usermode 3 (in :Trystan MODE Trystan :+AcdDfFGhHkKloRsSTuUvVWXyYzZ0123459)
[Jul 03 18:11:43.180876 2005] debug: unknown mode : usermode 4 (in :Trystan MODE Trystan :+AcdDfFGhHkKloRsSTuUvVWXyYzZ0123459)
[Jul 03 18:11:43.181098 2005] debug: unknown mode : usermode 5 (in :Trystan MODE Trystan :+AcdDfFGhHkKloRsSTuUvVWXyYzZ0123459)
[Jul 03 18:11:43.181308 2005] debug: unknown mode : usermode 9 (in :Trystan MODE Trystan :+AcdDfFGhHkKloRsSTuUvVWXyYzZ0123459)
*/
 
#define IRC_UMODE_a 0x00000001
#define IRC_UMODE_F 0x00000002
#define IRC_UMODE_m 0x00000004
#define IRC_UMODE_i 0x00000008
#define IRC_UMODE_r 0x00000010  
#define IRC_UMODE_w 0x00000020  
#define IRC_UMODE_h 0x00000040  
#define IRC_UMODE_b 0x00000080
#define IRC_UMODE_c 0x00000100
#define IRC_UMODE_d 0x00000200
#define IRC_UMODE_f 0x00000400
#define IRC_UMODE_g 0x00000800
#define IRC_UMODE_k 0x00001000
#define IRC_UMODE_l 0x00002000
#define IRC_UMODE_n 0x00004000
#define IRC_UMODE_s 0x00008000
#define IRC_UMODE_u 0x00010000
#define IRC_UMODE_x 0x00020000
#define IRC_UMODE_y 0x00040000
#define IRC_UMODE_z 0x00080000
#define IRC_UMODE_S 0x00100000
#define IRC_UMODE_o 0x00200000
#define IRC_UMODE_p 0x00400000
#define IRC_UMODE_e 0x00800000
#define IRC_UMODE_B 0x01000000
#define IRC_UMODE_A 0x02000000
#define IRC_UMODE_D 0x04000000
#define IRC_UMODE_G 0x08000000
#define IRC_UMODE_H 0x10000000
#define IRC_UMODE_K 0x20000000
#define IRC_UMODE_R 0x40000000
#define IRC_UMODE_T 0x80000000


#define IRCD_CMODE_i 0x00000001     /* Invite only */
#define IRCD_CMODE_m 0x00000002     /* Users without +v/h/o cannot send text to the channel */
#define IRCD_CMODE_n 0x00000004     /* Users must be in the channel to send text to it */
#define IRCD_CMODE_p 0x00000008     /* Private is obsolete, this now restricts KNOCK */
#define IRCD_CMODE_s 0x00000010     /* The channel does not show up on NAMES or LIST */
#define IRCD_CMODE_t 0x00000020     /* Only chanops can change the topic */
#define IRCD_CMODE_k 0x00000040     /* Key/password for the channel. */
#define IRCD_CMODE_l 0x00000080     /* Limit the number of users in a channel */
#define IRCD_CMODE_A 0x00000100
#define IRCD_CMODE_O 0x00000200
#define IRCD_CMODE_I 0x00000400
#define IRCD_CMODE_a 0x00000800     /* Anonymous ops, chanops are hidden */

void hyperion_cmd_nick(char *nick, char *name, const char *modes);
void hyperion_cmd_mode(char *source, char *dest, char *buf);
void hyperion_cmd_bot_nick(char *nick, char *user, char *host, char *real, char *modes);
void hyperion_cmd_notice(char *source, char *dest, char *buf);
void hyperion_cmd_privmsg(char *source, char *dest, char *buf);
void hyperion_cmd_serv_notice(char *source, char *dest, char *msg);
void hyperion_cmd_serv_privmsg(char *source, char *dest, char *msg);
void hyperion_cmd_351(char *source);
void hyperion_cmd_quit(char *source, char *buf);
void hyperion_cmd_pong(char *servname, char *who);
void hyperion_cmd_join(char *user, char *channel, time_t chantime);
void hyperion_cmd_part(char *nick, char *chan, char *buf);
void hyperion_cmd_global(char *source, char *buf);
void hyperion_cmd_squit(char *servname, char *message);
void hyperion_cmd_connect(void);
void hyperion_cmd_eob(void);
void hyperion_cmd_ctcp(char *source, char *dest, char *buf);
void hyperion_cmd_version(char *server);
void hyperion_cmd_stats(char *sender, const char *letter, char *server);
void hyperion_cmd_motd(char *sender, char *server);
void hyperion_cmd_ping(char *server);
void hyperion_cmd_pass(char *pass);
void hyperion_cmd_server(char *servname, int hop, char *descript);
void hyperion_cmd_capab(void);
void hyperion_cmd_svinfo(void);

int denora_event_sqline(char *source, int ac, char **av);
int denora_event_436(char *source, int ac, char **av);
int denora_event_away(char *source, int ac, char **av);
int denora_event_ping(char *source, int ac, char **av);
int denora_event_motd(char *source, int ac, char **av);
int denora_event_join(char *source, int ac, char **av);
int denora_event_kick(char *source, int ac, char **av);
int denora_event_kill(char *source, int ac, char **av);
int denora_event_mode(char *source, int ac, char **av);
int denora_event_quit(char *source, int ac, char **av);
int denora_event_squit(char *source, int ac, char **av);
int denora_event_topic(char *source, int ac, char **av);
int denora_event_whois(char *source, int ac, char **av);
int denora_event_part(char *source, int ac, char **av);
int denora_event_server(char *source, int ac, char **av);
int denora_event_nick(char *source, int ac, char **av);
int denora_event_privmsg(char *source, int ac, char **av);
int denora_event_capab(char *source, int ac, char **av);
int denora_event_sjoin(char *source, int ac, char **av);
int denora_event_svinfo(char *source, int ac, char **av);
int denora_event_svsinfo(char *source, int ac, char **av);
int denora_event_eob(char *source, int ac, char **av);
int denora_event_pass(char *source, int ac, char **av);
int denora_event_error(char *source, int ac, char **av);
int denora_event_notice(char *source, int ac, char **av);
int denora_event_globops(char *source, int ac, char **av);
int denora_event_burst(char *source, int ac, char **av);
int denora_event_pong(char *source, int ac, char **av);
int denora_event_swhois(char *source, int ac, char **av);
int denora_event_sethost(char *source, int ac, char **av);
int denora_event_tburst(char *source, int ac, char **av);

int DenoraInit(int argc, char **argv);
void moduleAddIRCDMsgs(void);
void moduleAddIRCDCmds(void);
void DenoraFini(void);
